@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

set /A failure_count=0
SETLOCAL
:do_clean_factory_params
    call :view_clean_fac_param_ver

    set securestate=
    for /f "tokens=2 delims=: " %%i in ('%fastboot% -s %serial_number% getvar securestate 2^>^&1^| findstr securestate') do (set securestate=%%i)

    call :view_clean_fac_device_securestate "%securestate%"

    if "%securestate%" NEQ "engineering" (
        call :view_clean_fac_device_is_not_eng !serial_number!
        goto :end_check
    )

    REM =============================================================
    REM Check cmdl
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config cmdl 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set _resp=%%i)

    call :view_clean_fac_device_cmdl "%_resp%"

    if "%_resp%" NEQ "" (
        call :view_clean_fac_clear_cmdl
        !fastboot! -s !serial_number! oem config cmdl ""
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_clear_cmdl_failed
        )
    )

    REM =============================================================

    REM =============================================================
    REM Check power off mode charge
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem off-mode-charge 2^>^&1 ^| findstr "off_mode_charge" ^| %%awk%% -F"off_mode_charge " "{print $2}"`) do (
        set _resp=%%i
    )

    call :view_clean_fac_device_offmodecharge "%_resp%"

    if "%_resp%" == "disabled" (
        call :view_clean_fac_enable_offmodecharge
        !fastboot! -s !serial_number! oem off-mode-charge enable
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_enable_offmodecharge_failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check ramdump status
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem ramdump status 2^>^&1 ^| findstr "RAM dump" ^| %%awk%% -F"RAM dump " "{print $2}"`) do (
        set _resp=%%i
    )

    call :view_clean_fac_device_ramdump "%_resp%"

    if "%_resp%" == "enabled" (
        call :view_clean_fac_disable_ramdump
        !fastboot! -s !serial_number! oem ramdump disable
        !fastboot! -s !serial_number! oem ramdump disable
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_disable_ramdump_failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check memtest mode
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config memtest_mode 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set _resp=%%i)

    call :view_clean_fac_device_memtestmode "%_resp%"

    if "%_resp%" NEQ "" (
        call :view_clean_fac_disable_memtestmode
        !fastboot! -s !serial_number! oem config memtest_mode ""
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_disable_memtestmode_failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check console param
    set _resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config console 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set _resp=%%i)

    call :view_clean_fac_device_console "%_resp%"

    if "%_resp%" NEQ "" (
        call :view_clean_fac_clear_console
        !fastboot! -s !serial_number! oem config console ""
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_clean_fac_clear_console_failed
        )
    )
    REM =============================================================

    :end_check
    ENDLOCAL
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_clean_fac_param_ver
    echo.
    echo clean-factory-param v1.0.0-2023-09-09
exit /b 0
::
:view_clean_fac_device_securestate
    echo.
    echo Current device security status: [%~1]
exit /b 0
::
:view_clean_fac_device_is_not_eng
    echo.
    echo The Device [%1] is not in engineering mode, parameter check skipped.
exit /b 0
::
:view_clean_fac_device_cmdl
    echo.
    echo Current cmdl parameters: [%~1]
exit /b 0
::
:view_clean_fac_get_cmdl_failed
    echo WARNING: Get the cmdl failed
exit /b 0
::
:view_clean_fac_clear_cmdl
    echo.
    echo ==^> Cleaning up the kernel command line...
exit /b 0
::
:view_clean_fac_clear_cmdl_failed
    echo [Warning] Failed to clean kernel command line!
exit /b 0
::
:view_clean_fac_device_offmodecharge
    echo Current off-mode-charge status: [%~1]
exit /b 0
::
:view_clean_fac_enable_offmodecharge
    echo.
    echo ==^> Enable off-mode-charge mode...
exit /b 0
::
:view_clean_fac_enable_offmodecharge_failed
    echo [Warning] Failed to enable off-mode-charge^^!
exit /b 0
::
:view_clean_fac_device_ramdump
    echo Current ramdump status: [%~1]
exit /b 0
::
:view_clean_fac_disable_ramdump
    echo.
    echo ==^> Disabling ramdump...
exit /b 0
::
:view_clean_fac_disable_ramdump_failed
    echo [Warning] Disabling ramdump failed^^!
exit /b 0
::
:view_clean_fac_device_memtestmode
    echo Current memtest_mode status: [%~1]
exit /b 0
::
:view_clean_fac_disable_memtestmode
    echo ==^> Disabling memtest mode...
exit /b 0
::
:view_clean_fac_disable_memtestmode_failed
    echo [Warning] Disabling ramdump failed^^!
exit /b 0
::
:view_clean_fac_device_console
    echo Current console parameters: [%~1]
exit /b 0
::
:view_clean_fac_clear_console
    echo ==^> Cleaning up the console...
exit /b 0
::
:view_clean_fac_clear_console_failed
    echo [Warning] Clearing console failed^^!
exit /b 0
