@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_bl_qcom
    REM return: 0 or 1

    REM GPT part
    set img_file=
    set img_name=GPT
    set pt_name=partition
    set /A A=0

    if exist gpt.bin (
        set /A A+=1
        set img_file=gpt.bin
    )
    if exist diskmap.pit set /A A+=1
    if exist PGPT set /A A+=1
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error2 !img_name!
        exit /b 1
    )
    if %A% == 1 (
        if "!img_file!" == "" (
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    ) else (
        call :view_flash_image_not_exist_w1 !img_name!
    )


    REM bootloader part
    set img_file=
    set img_name=BOOTLOADER
    set pt_name=bootloader
    set /A A=0

    if exist motoboot.img (
        set /A A+=1
        set img_name=MOTOBOOT
        set pt_name=motoboot
    )
    if exist bootloader.img (
        set /A A+=1
        set img_name=BOOTLOADER
        set img_file=bootloader.img
    )
    if exist bootloader.bin (
        set /A A+=1
        set img_name=BOOTLOADER
        set img_file=bootloader.bin
    )
    if exist preloader.bin set /A A+=1
    if exist preloader.img set /A A+=1

    if %A% GTR 1 (
        call :view_flash_image_duplicate_error2 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        call :view_flash_image_not_exist_e !img_name!
        exit /b 1
    )
    REM if %A% == 1 / 0
    if %A% == 1 (
        if "!img_file!" == "" (
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    ) else (
        call :view_flash_image_not_exist_w !img_name!
    )

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_duplicate_error2
    color fc
    echo.
    echo [Fatal] Different formats %1 image exists at the same time, this is obviously wrong, please check^^!
exit /b 0
::
:view_flash_image_not_exist_e
    color fc
    echo.
    echo [Fatal] Image %1 does not exist. This is obviously wrong, please check the firmware location path^^!
exit /b 0
::
:view_flash_image_format_error
    color fc
    echo.
    echo [Fatal] Wrong %1 image format. This is obviously wrong, please check^^!
exit /b 0
::
:view_flash_image_not_exist_w
    echo.
    echo [Warning] Image %1 does not exist. But your device contain this partition, flashing skipped...
exit /b 0
::
:view_flash_image_not_exist_w1
    echo.
    echo [Warning] Image %1 does not exist. Flashing skipped...
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ Flashing %1 image ------
exit /b 0
::
:view_flash_image_fatal_failed
    color fc
    echo ------------------------------
    echo [Fatal] fastboot flashing %1 failed^^!
    echo ------------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
