@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_bl_slsi
    REM return: 0 or 1

    REM GPT part
    set img_file=
    set img_name=PIT
    set pt_name=pit
    set /A A=0

    if exist gpt.bin set /A A+=1
    if exist diskmap.pit (
        set /A A+=1
        set img_file=diskmap.pit
    )
    if exist PGPT set /A A+=1

    if %A% GTR 1 (
        call :view_flash_image_duplicate_error2 !img_name!
        exit /b 1
    )
    if %A% == 1 (
        if "!img_file!" == "" (
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    ) else (
        call :view_flash_image_not_exist_w1 !img_name!
    )

    if "%FLAG_DEVICE_HAS_FWBL1%" == "1" (
        set img_file=
        set img_name=FWBL1
        set pt_name=fwbl1
        set /A A=0

        if exist fwbl1.nbl1.bin (
            set /A A+=1
            set img_file=fwbl1.nbl1.bin
        )
        if exist fwbl1.img (
            set /A A+=1
            set img_file=fwbl1.img
        )
        if !A! GTR 1 (
            call :view_flash_image_duplicate_error "fwbl1.nbl1.bin fwbl1.img"
            exit /b 1
        )
        REM if !A! == 1 / 0
        if !A! == 1 (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed !img_name!
                exit /b 1
            )
        ) else (
            REM if !A! == 0
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_LDFW%" == "1" (
        set img_file=
        set img_name=LDFW
        set pt_name=fwbl1
        set /A A=0
        if exist ldfw.bin (
            set /A A+=1
            set img_file=ldfw.bin
        )
        if exist ldfw.img (
            set /A A+=1
            set img_file=ldfw.img
        )
        if !A! GTR 1 (
            call :view_flash_image_duplicate_error "ldfw.bin" "ldfw.img"
            exit /b 1
        )
        if !A! == 1 (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            REM if !A! == 0
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    if "%FLAG_DEVICE_HAS_KEYSTORAGE%" EQU "1" (
        set img_file=
        set img_name=KEYSTORAGE
        set pt_name=keystorage
        set /A A=0
        if exist keystorage.bin (
            set /A A+=1
            set img_file=keystorage.bin
        )
        if exist keystorage.img (
            set /A A+=1
            set img_file=keystorage.img
        )
        if !A! GTR 1 (
            call :view_flash_image_duplicate_error "keystorage.bin" "keystorage.img"
            exit /b 1
        )
        if !A! == 1 (
            set pt_list=_a _b
            for %%a in (!pt_list!) do (
                call :view_flash_image_title !pt_name!%%a
                !fastboot! -s !serial_number! flash !pt_name!%%a !img_file!
                if !errorlevel! == 1 (
                    call :view_flash_image_fatal_failed %%a
                    exit /b 1
                )
            )
        ) else (
            REM if !A! == 0
            call :view_flash_image_not_exist_w !img_name!
        )
    )

    REM bootloader part
    set img_file=
    set img_name=BOOTLOADER
    set pt_name=bootloader
    set /A A=0

    if exist motoboot.img set /A A+=1
    if exist bootloader.img (
        set /A A+=1
        set img_file=bootloader.img
    )
    if exist bootloader.bin (
        set /A A+=1
        set img_file=bootloader.bin
    )
    if exist preloader.bin  set /A A+=1
    if exist preloader.img  set /A A+=1
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error2 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        call :view_flash_image_not_exist_e !img_name!
        exit /b 1
    )
    if %A% == 1 (
        if "!img_file!" == "" (
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        set pt_list=_a _b
        for %%a in (!pt_list!) do (
            call :view_flash_image_title !pt_name!%%a
            !fastboot! -s !serial_number% flash !pt_name!%%a !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
    )

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_duplicate_error
    color fc
    echo.
    echo [Fatal] Image %1 exists at the same time, this is obviously wrong, please check^^!
exit /b 0
::
:view_flash_image_duplicate_error2
    color fc
    echo.
    echo [Fatal] Different formats %1 image exists at the same time, this is obviously wrong, please check^^!
exit /b 0
::
:view_flash_image_not_exist_e
    color fc
    echo.
    echo [Fatal] Image %1 does not exist. This is obviously wrong, please check the firmware location path^^!
exit /b 0
::
:view_flash_image_not_exist_w
    echo.
    echo [Warning] Image %1 does not exist. But your device contain this partition, flashing skipped...
exit /b 0
::
:view_flash_image_not_exist_w1
    echo.
    echo [Warning] Image %1 does not exist. Flashing skipped...
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ Flashing %1 image ------
exit /b 0
::
:view_flash_image_fatal_failed
    color fc
    echo ------------------------------
    echo [Fatal] fastboot flashing %1 failed^^!
    echo ------------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
