@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:enumerate_adb_devices
    call :view_fb_not_adb_tips
    call :view_currect_adb_in_use
    %adb% --version

    call :view_start_adb_server
    %adb% start-server
    if %errorlevel% == 1 (
        call :view_start_adb_server_failed_tips
        goto :exit_enumeration
    )
    call :finding_adb_device

    set device_timeout=0
    set wait_time=60
    set remain_time=0
    :enumerate_adb_loop
        set DEVICE_COUNT=0
        set _device_list=
        for /F "usebackq tokens=*" %%X in (`%%adb%% devices 2^>^&1 ^| %%grep%% -vE "List of|^[[:space:]]*$" ^| %%awk%% "{print $1 \":\" $2}"`) do (
            if "%%X" NEQ "" (
                set /A DEVICE_COUNT+=1
                set _device_list=%%X !_device_list!
            )
        )

        set _device_sn_list=
        for /F "usebackq tokens=*" %%Y in (`echo.%_device_list% ^| %%tr%% " " "\n" ^| %%awk%% -F":" "{print $1}"`) do (
            set _device_sn_list=%%Y !_device_sn_list!
        )

        set /A device_timeout+=1
        set /A remain_time=%wait_time% - %device_timeout%

        if "%_device_sn_list%" NEQ "" (
            echo !_device_list! | !tr! " " "\n" | !awk! -F":" "{print $2}" | !grep! -Eq "offline|unauthorized"
            if !errorlevel! == 0 (
                call :view_detected_not_working_device !remain_time!
            ) else (
                set _device_list=!_device_sn_list!
                goto :end_enumerate_adb_loop
            )
        ) else (
            call :view_device_connect_waitingfor !remain_time!
        )

        if "%device_timeout%" == "%wait_time%" (
            call :view_device_connect_timeout
            goto :exit_enumeration
        )

        ping 127.0.1 -n 2 >nul 2>nul
    goto :enumerate_adb_loop

    :end_enumerate_adb_loop
    for /F "usebackq tokens=*" %%X in (`echo %%_device_list%% ^| %%awk%% "{$1=$1; print}"`) do (
        set DEVICE_LIST=%%X
    )

    call :view_adb_device_conn %DEVICE_COUNT% %DEVICE_LIST%
    set _device_list=
    set _device_sn_list=
    set wait_time=
    set device_timeout=
    set remain_time=
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_fb_not_adb_tips
    echo.
    echo Note: ADB can only be used after the System is started. ADB is not Fastboot, Fastboot is certainly not ADB.
exit /b 0
::
:view_currect_adb_in_use
    echo.
    REM currect adb version
    echo [Debug] The adb version currently in use:
exit /b 0
::
:view_start_adb_server
    echo.
    echo Starting ADB service...
exit /b 0
::
:view_start_adb_server_failed_tips
    color fc
    echo.
    echo [Fatal] Start ADB Server failed^^!
    echo Please check and try to uninstall all phone assistant or other ROM flash helpers^^!
exit /b 0
::
:finding_adb_device
    echo.
    echo Finding ADB device...
exit /b 0
::
:view_detected_not_working_device
    echo.
    echo Unauthorized device detected. Please Check the "Always allow from this comuter" option and Click "Allow" button.
    echo If there is a device that does not need to execute ADB commands, please remove it from the computer.
    echo Please perform the operation within [%1] seconds.
exit /b 0
::
:view_device_connect_waitingfor
    echo.
    echo ==^> Waiting for device to connect. [%1] seconds remaining.
exit /b 0
::
:view_device_connect_timeout
    echo.
    echo [Fatal] Connection timed out. Please check your device connection.
exit /b 0
::
:view_adb_device_conn
    echo.
    echo Currently %1 ADB devices connected: [%2]
    echo.
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo Press any key to exit.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit_enumeration
    call "%~dp0do_kill_adb_server.cmd"
    call :view_press_any_key_exit
    pause > nul
exit
